import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import g4p_controls.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class hra_uzivatele extends PApplet {

// Need G4P library


int[][] pole=new int[8][8];
int oznx=-1,ozny=-1;
int body=0;
ArrayList<Integer> smazat=new ArrayList<Integer>();
ArrayList<ArrayList<Integer>> nahradni=new ArrayList<ArrayList<Integer>>();
int[] poradi=new int[8];
boolean konec=true;
int ukoncit=-1;

public void setup(){
  
  createGUI();
  customGUI();
  // Place your setup code here
    stroke(0);
  byte[] soubor=loadBytes("vstup.txt");
  for (int i=0;i<80;i++){
    if ((i%10==8)||(i%10==9)){
      continue;
    }
    pole[i/10][i%10]=soubor[i]-48;
  }
  for (int i=0;i<8;i++){
    nahradni.add(new ArrayList<Integer>());
  }
  int i=80;
  int sloupec=0;
  boolean radek=true;
  while (i<soubor.length){
    if ((soubor[i]>=48)&&(soubor[i]<=54)){
      if (!radek) sloupec++;
      nahradni.get(sloupec).add(soubor[i]-48);
      radek=true;
    }else{
      radek=false;
    }
    i++;
  }
}

public void draw(){
   background(255);
 int hra=0;
 for (int i=0;i<8;i++){
   switch (nahradni.get(i).get(poradi[i])){
     case 0:
       fill(0);
       break;
     case 1:
       fill(255,0,0);
       break;
     case 2:
       fill(0,255,0);
       break;
     case 3:
       fill(0,0,255);
       break;
     case 4:
       fill(255);
       break;
     case 5:
       fill(255,255,0);
       break;
     case 6:
       fill(255,0,255);
       break;
   }
   ellipse(i*50+25,25,40,40); 
 }
 line(5,50,395,50);
 for (int y=0;y<8;y++){
   for (int x=0;x<8;x++){
     if (y+1<8) hra+=sledy(x,y,x,y+1);
     if (x+1<8) hra+=sledy(x,y,x+1,y);
     switch (pole[y][x]){
       case 0:
         fill(0);
         break;
       case 1:
         fill(255,0,0);
         break;
       case 2:
         fill(0,255,0);
         break;
       case 3:
         fill(0,0,255);
         break;
       case 4:
         fill(255);
         break;
       case 5:
         fill(255,255,0);
         break;
       case 6:
         fill(255,0,255);
         break;
     }
     ellipse(x*50+25,y*50+75,40,40); 
     if (sledy(x,y,x,y)>0){
       smazat.add(x);
       smazat.add(y);
     }
     body+=sledy(x,y,x,y);
   }
 }
 for (int i=0;i<smazat.size();i+=2){
   pole[smazat.get(i+1)][smazat.get(i)]=0;
 }
 smazat.clear();
 for (int x=0;x<8;x++){
   boolean k=false;
   while (!k){
     k=true;
     for (int y=7;y>0;y--){
       if ((pole[y][x]==0)&&(pole[y-1][x]!=0)){
         pole[y][x]=pole[y-1][x];
         pole[y-1][x]=0;
         k=false;
       }
     }
   }
 }
 for (int x=0;x<8;x++){
   for (int y=7;y>=0;y--){
     if (pole[y][x]==0){
       pole[y][x]=nahradni.get(x).get(poradi[x]);
       poradi[x]++;
       if (poradi[x]>=nahradni.get(x).size()){
         poradi[x]=0;
       }
     }
   }
 }
 fill(0);
 text("Body: "+body,5,460);
 if (ukoncit>-1){
 int zbyva=max(ukoncit-millis(),0);
 text("Zb\u00fdvaj\u00edc\u00ed \u010das: "+zbyva/60000+":"+zbyva%60000/1000,100,460);
 }
 if ((hra==0)||((millis()>ukoncit)&&(ukoncit>-1))){
   text("Konec hry",200,250);
   konec=true;
 }
 noFill();
 rect(oznx*50,ozny*50+50,50,50);  
}

public void mouseClicked(){
  if (konec) return;
  if ((oznx!=-1)&&(ozny!=-1)){
    int noznx=mouseX/50;
    int nozny=mouseY/50-1;
    if (((noznx==oznx)&&(abs(nozny-ozny)==1))||((nozny==ozny)&&(abs(noznx-oznx)==1))){
      if (sledy(oznx,ozny,noznx,nozny)>0){
        int puvodni=pole[ozny][oznx];
        pole[ozny][oznx]=pole[nozny][noznx];
        pole[nozny][noznx]=puvodni;
      }
      oznx=-1;
      ozny=-1;
    }else{
      oznx=noznx;
      ozny=nozny;
    }
  }else{
    oznx=mouseX/50;
    ozny=mouseY/50-1;
  }
}

public int sledy(int x, int y, int nx, int ny){
  int[][] kopie=new int[8][8];
  for (int i=0;i<8;i++){
    arrayCopy(pole[i],kopie[i]);  
  } 
  int res=0;
  int puvodni=kopie[y][x];
  kopie[y][x]=kopie[ny][nx];
  kopie[ny][nx]=puvodni;
  if (x+2<8)
  if ((kopie[y][x]==kopie[y][x+1])&&(kopie[y][x]==kopie[y][x+2])) res++;
  if ((x+1<8)&&(x-1>=0))
  if ((kopie[y][x]==kopie[y][x+1])&&(kopie[y][x]==kopie[y][x-1])) res++;
  if (x-2>=0)
  if ((kopie[y][x]==kopie[y][x-1])&&(kopie[y][x]==kopie[y][x-2])) res++; 
  if (y+2<8)
  if ((kopie[y][x]==kopie[y+1][x])&&(kopie[y][x]==kopie[y+2][x])) res++;
  if ((y+1<8)&&(y-1>=0))
  if ((kopie[y][x]==kopie[y+1][x])&&(kopie[y][x]==kopie[y-1][x])) res++;
  if (y-2>=0)
  if ((kopie[y][x]==kopie[y-1][x])&&(kopie[y][x]==kopie[y-2][x])) res++;   
  if ((nx!=x)||(ny!=y)){
    if (nx+2<8)
    if ((kopie[ny][nx]==kopie[ny][nx+1])&&(kopie[ny][nx]==kopie[ny][nx+2])) res++;
    if ((nx+1<8)&&(nx-1>=0))
    if ((kopie[ny][nx]==kopie[ny][nx+1])&&(kopie[ny][nx]==kopie[ny][nx-1])) res++;
    if (nx-2>=0)
    if ((kopie[ny][nx]==kopie[ny][nx-1])&&(kopie[ny][nx]==kopie[ny][nx-2])) res++;
    if (ny+2<8)
    if ((kopie[ny][nx]==kopie[ny+1][nx])&&(kopie[ny][nx]==kopie[ny+2][nx])) res++;
    if ((ny+1<8)&&(ny-1>=0))
    if ((kopie[ny][nx]==kopie[ny+1][nx])&&(kopie[ny][nx]==kopie[ny-1][nx])) res++; 
    if (ny-2>=0)
    if ((kopie[ny][nx]==kopie[ny-1][nx])&&(kopie[ny][nx]==kopie[ny-2][nx])) res++;
  }
  return res;
}

// Use this method to add additional statements
// to customise the GUI controls
public void customGUI(){

}
/* =========================================================
 * ====                   WARNING                        ===
 * =========================================================
 * The code in this tab has been generated from the GUI form
 * designer and care should be taken when editing this file.
 * Only add/edit code inside the event handlers i.e. only
 * use lines between the matching comment tags. e.g.

 void myBtnEvents(GButton button) { //_CODE_:button1:12356:
     // It is safe to enter your event code here  
 } //_CODE_:button1:12356:
 
 * Do not rename this tab!
 * =========================================================
 */

public void checkbox1_clicked1(GCheckbox source, GEvent event) { //_CODE_:checkbox1:682660:
  println("checkbox1 - GCheckbox >> GEvent." + event + " @ " + millis());
} //_CODE_:checkbox1:682660:

public void textfield1_change1(GTextField source, GEvent event) { //_CODE_:textfield1:619709:
  println("textfield1 - GTextField >> GEvent." + event + " @ " + millis());
} //_CODE_:textfield1:619709:

public void button1_click1(GButton source, GEvent event) { //_CODE_:button1:328209:
  konec=false;
  String text=textfield1.getText();
  if (checkbox1.isSelected()){
    ukoncit=millis()+Integer.valueOf(text.substring(0,text.indexOf(":")))*60000+Integer.valueOf(text.substring(text.indexOf(":")+1))*1000;
  }
} //_CODE_:button1:328209:



// Create all the GUI controls. 
// autogenerated do not edit
public void createGUI(){
  G4P.messagesEnabled(false);
  G4P.setGlobalColorScheme(GCScheme.BLUE_SCHEME);
  G4P.setCursor(ARROW);
  surface.setTitle("Sketch Window");
  label1 = new GLabel(this, 400, 100, 80, 20);
  label1.setText("\u010casov\u00fd limit:");
  label1.setOpaque(false);
  checkbox1 = new GCheckbox(this, 400, 125, 60, 20);
  checkbox1.setTextAlign(GAlign.LEFT, GAlign.MIDDLE);
  checkbox1.setText("Pou\u017e\u00edt");
  checkbox1.setOpaque(false);
  checkbox1.addEventHandler(this, "checkbox1_clicked1");
  textfield1 = new GTextField(this, 400, 150, 90, 15, G4P.SCROLLBARS_NONE);
  textfield1.setOpaque(true);
  textfield1.addEventHandler(this, "textfield1_change1");
  button1 = new GButton(this, 400, 180, 80, 30);
  button1.setText("Start");
  button1.addEventHandler(this, "button1_click1");
}

// Variable declarations 
// autogenerated do not edit
GLabel label1; 
GCheckbox checkbox1; 
GTextField textfield1; 
GButton button1; 
  public void settings() {  size(500,470, JAVA2D); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "hra_uzivatele" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
